
//=======================================================
//  This code is generated by Terasic System Builder
//=======================================================

module Camera(

	//////////// CLOCK //////////
	input 		          		CLOCK2_50,
	input 		          		CLOCK3_50,
	input 		          		CLOCK_50,

	//////////// LED //////////
	output		     [8:0]		LEDG,
	output		    [17:0]		LEDR,

	//////////// KEY //////////
	input 		     [3:0]		KEY,

	//////////// SW //////////
	input 		    [17:0]		SW,

	//////////// SEG7 //////////
	output		     [6:0]		HEX0,
	output		     [6:0]		HEX1,
	output		     [6:0]		HEX2,
	output		     [6:0]		HEX3,
	output		     [6:0]		HEX4,
	output		     [6:0]		HEX5,
	output		     [6:0]		HEX6,
	output		     [6:0]		HEX7,

	//////////// I2C for HSMC  //////////
	output		          		I2C_SCLK,
	inout 		          		I2C_SDAT,

	//////////// SDRAM //////////
	output		    [12:0]		DRAM_ADDR,
	output		     [1:0]		DRAM_BA,
	output		          		DRAM_CAS_N,
	output		          		DRAM_CKE,
	output		          		DRAM_CLK,
	output		          		DRAM_CS_N,
	inout 		    [31:0]		DRAM_DQ,
	output		     [3:0]		DRAM_DQM,
	output		          		DRAM_RAS_N,
	output		          		DRAM_WE_N,

	//////////// GPIO, GPIO connect to GPIO Default //////////
	inout 		    [35:0]		GPIO,

	//////////// HSMC, HSMC connect to MTLC2 -Multi-Touch/LCD/Camera //////////
	inout 		          		CAMERA_I2C_SCL,
	inout 		          		CAMERA_I2C_SDA,
	output		          		CAMERA_PWDN_n,
	input 		          		CMP_DRDY,
	inout 		          		CMP_SCL,
	inout 		          		CMP_SDA,
	output		     [7:0]		LCD_B,
	output		          		LCD_DCLK,
	output		          		LCD_DE,
	output		          		LCD_DIM,
	output		          		LCD_DITH,
	output		     [7:0]		LCD_G,
	output		          		LCD_HSD,
	output		          		LCD_MODE,
	output		          		LCD_POWER_CTL,
	output		          		LCD_RSTB,
	output		     [7:0]		LCD_R,
	output		          		LCD_SHLR,
	output		          		LCD_UPDN,
	output		          		LCD_VSD,
	output		          		LSENSOR_ADDR_SEL,
	input 		          		LSENSOR_INT,
	inout 		          		LSENSOR_SCL,
	inout 		          		LSENSOR_SDA,
	output		          		MIPI_CS_n,
	inout 		          		MIPI_I2C_SCL,
	inout 		          		MIPI_I2C_SDA,
	//output		          		MIPI_MCLK,
	input 		          		MIPI_PIXEL_CLK,
	input 		    [13:0]		MIPI_PIXEL_D,
	input 		          		MIPI_PIXEL_HS,
	input 		          		MIPI_PIXEL_VS,
	output		          		MIPI_REFCLK,
	output		          		MIPI_RESET_n,
	output		          		MPU_AD0_SDO,
	output		          		MPU_CS_n,
	output		          		MPU_FSYNC,
	input 		          		MPU_INT,
	inout 		          		MPU_SCL_SCLK,
	inout 		          		MPU_SDA_SDI,
	inout 		          		TOUCH_I2C_SCL,
	inout 		          		TOUCH_I2C_SDA,
	input 		          		TOUCH_INT_n
);




//=======================================================
//  REG/WIRE declarations
//=======================================================


///////////////////////////////////

wire [7:0] lcd_r;
wire [7:0] lcd_g;
wire [7:0] lcd_b;
wire       lcd_clk;
wire       lcd_hs;
wire       lcd_vs;

wire	[15:0]SDRAM_RD_DATA;
wire			DLY_RST_0;
wire			DLY_RST_1;
wire			DLY_RST_2;

wire			SDRAM_CTRL_CLK;
wire        D8M_CK_HZ ; 
wire        D8M_CK_HZ2 ; 
wire        D8M_CK_HZ3 ; 

wire [11:0] RED   ; 
wire [11:0] GREEN  ; 
wire [11:0] BLUE 		 ; 
wire [12:0] VGA_H_CNT;			
wire [12:0] VGA_V_CNT;	

wire        READ_Request ;
wire 	[7:0] B_AUTO;
wire 	[7:0] G_AUTO;
wire 	[7:0] R_AUTO;
wire        RESET_N  ; 

wire        I2C_RELEASE ;  
wire        AUTO_FOC ; 
wire        CAMERA_I2C_SCL_MIPI ; 
wire        CAMERA_I2C_SCL_AF;
wire        CAMERA_MIPI_RELAESE ;
wire        MIPI_BRIDGE_RELEASE ; 
wire   [9:0]MIPI_PIXEL_D_ ;
wire        MIPI_PIXEL_VS_; 
wire        MIPI_PIXEL_HS_;  
 
//=============================================================================
// Structural coding
//=============================================================================

// MTLC2 - display
assign {LCD_R,LCD_G,LCD_B} =  {lcd_r, lcd_g, lcd_b};
assign LCD_DCLK            =  lcd_clk;
assign LCD_HSD             =  lcd_hs;
assign LCD_VSD             =  lcd_vs;
assign LCD_DE              =  READ_Request ; 

	
assign LCD_MODE      = 1'b0;  //HSD/VSD mode
assign LCD_RSTB      = 1'b1;  //NO RESET
assign LCD_DIM       = 1'b1;
assign LCD_POWER_CTL = 1'b1;
assign LCD_SHLR  	   = 1'b1;
assign LCD_UPDN 	   = 1'b0;


assign UART_RTS      = 0; 
assign UART_TXD      = 0; 


//------ MIPI BRIGE & CAMERA RESET  --
assign CAMERA_PWDN_n  = 1; 
assign MIPI_CS_n      = 0; 
assign MIPI_RESET_n   = RESET_N ;

//------ CAMERA MODULE I2C SWITCH  --
assign I2C_RELEASE    = CAMERA_MIPI_RELAESE & MIPI_BRIDGE_RELEASE; 
assign CAMERA_I2C_SCL = ( I2C_RELEASE  )?  CAMERA_I2C_SCL_AF  : CAMERA_I2C_SCL_MIPI ;   
 

//------MIPI / VGA REF CLOCK  --
pll_test pll_ref(
	                 .inclk0 ( CLOCK2_50 ),
	                 .areset ( 0 ),          
	                 .c0     ( MIPI_REFCLK ), //20MHz
	                 .c1     ( lcd_clk )      //33.333MHz	
                  );
	 
//------SDRAM CLOCK GENNERATER  --
sdram_pll u6(
		               .areset( 0 ) ,     
		               .inclk0( CLOCK2_50  ),              
		               .c1    ( DRAM_CLK ),       //100MHZ   -90 degree
		               .c0    ( SDRAM_CTRL_CLK )  //100MHZ     0 degree 							
		              
	               );	
		
		
 
//----- RESET RELAY  --		
RESET_DELAY			u2	(	
							.iRST  ( KEY[0] ),
                     .iCLK  ( CLOCK2_50 ),
							.oRST_0( DLY_RST_0 ),
							.oRST_1( DLY_RST_1 ),
							.oRST_2( DLY_RST_2 ),					
						   .oREADY( RESET_N)  
							
						);
						
						
// I2C configure for Camera and MIPI decoder
//------ MIPI BRIDGE & CAMERA SETTING  --  
MIPI_BRIDGE_CAMERA_Config    cfin(
                      .RESET_N           ( RESET_N ), 
                      .CLK_50            ( CLOCK2_50 ), 
                      .MIPI_I2C_SCL      ( MIPI_I2C_SCL ), 
                      .MIPI_I2C_SDA      ( MIPI_I2C_SDA ), 
                      .MIPI_I2C_RELEASE  ( MIPI_BRIDGE_RELEASE ),  
                      .CAMERA_I2C_SCL    ( CAMERA_I2C_SCL_MIPI ),
                      .CAMERA_I2C_SDA    ( CAMERA_I2C_SDA ),
                      .CAMERA_I2C_RELAESE( CAMERA_MIPI_RELAESE )
             );
				 	 

//---RE-TRIGGER ---
RE_TRIGGER  tr( 
       .iCLK ( MIPI_PIXEL_CLK ), 
       .iD   ( MIPI_PIXEL_D   ), 
       .iHS  ( MIPI_PIXEL_HS  ),
       .iVS  ( MIPI_PIXEL_VS  ),			 
       .oD   ( MIPI_PIXEL_D_  ), 
       .oHS  ( MIPI_PIXEL_HS_ ),
       .oVS  ( MIPI_PIXEL_VS_ )
);	 


//------SDRAM CONTROLLER --
Sdram_Control	   u7	(	//	HOST Side						
						   .RESET_N     ( KEY[0] ),
							.CLK         ( SDRAM_CTRL_CLK ) , 
							//	FIFO Write Side 1
							.WR1_DATA    ( MIPI_PIXEL_D[9:0] ),
							.WR1         ( MIPI_PIXEL_HS & MIPI_PIXEL_VS ) ,
							
							.WR1_ADDR    ( 0 ),
                     .WR1_MAX_ADDR( 800*480 ),
						   .WR1_LENGTH  ( 256 ) , 
		               .WR1_LOAD    ( !DLY_RST_0 ),
							.WR1_CLK     ( MIPI_PIXEL_CLK ),

                     //	FIFO Read Side 1
						   .RD1_DATA    ( SDRAM_RD_DATA[9:0] ),
				        	.RD1         ( READ_Request ),
				        	.RD1_ADDR    ( 0 ),
                     .RD1_MAX_ADDR( 800*480 ),
							.RD1_LENGTH  ( 256  ),
							.RD1_LOAD    ( !DLY_RST_1),
							.RD1_CLK     ( lcd_clk ),
											
							//	SDRAM Side
						   .SA          ( DRAM_ADDR ),
							.BA          ( DRAM_BA ),
							.CS_N        ( DRAM_CS_N ),
							.CKE         ( DRAM_CKE ),
							.RAS_N       ( DRAM_RAS_N ),
							.CAS_N       ( DRAM_CAS_N ),
							.WE_N        ( DRAM_WE_N ),
							.DQ          ( DRAM_DQ ),
							.DQM         ( DRAM_DQM  )
						   );

													
		
//------ CMOS CCD_DATA TO RGB_DATA -- 

RAW2RGB_J				u4	(	
							.RST          ( DLY_RST_1  ),
                     .CCD_PIXCLK   ( lcd_clk ),
							.mCCD_DATA    ( {SDRAM_RD_DATA[9:0] ,2'b00  }  ),
							.CCD_FVAL     ( lcd_vs ),
							.CCD_LVAL     ( lcd_hs ),

							//-----------------------------------
                     .VGA_CLK      ( lcd_clk ),
                     .READ_Request ( READ_Request ),
                     .VGA_VS       ( lcd_vs ),	
							.VGA_HS       ( lcd_hs ) , 
	                  .READ_Cont    ( READ_Cont ) , 
	                  .V_Cont       ( ), 
	                  			
							.oRed         ( RED  [11:0] ),
							.oGreen       ( GREEN[11:0] ),
							.oBlue        ( BLUE [11:0] ),
							.oDVAL        ( )

							);	
							
							
//------VGA Controller------

VGA_Controller		u1	(	//	Host Side
							 .oRequest   ( READ_Request ),
							 .iRed       ( RED   [11:4] ),
							 .iGreen     ( GREEN [11:4] ),
							 .iBlue      ( BLUE  [11:4] ),
							 
							 //	VGA Side
							 .oVGA_R     ( R_AUTO[7:0] ),
							 .oVGA_G     ( G_AUTO[7:0] ),
							 .oVGA_B     ( B_AUTO[7:0] ),
							 .oVGA_H_SYNC( lcd_hs ),
							 .oVGA_V_SYNC( lcd_vs ),
							 .oVGA_SYNC  (  ),
							 .oVGA_BLANK (  ),
							 //	Control Signal
							 .iCLK       ( lcd_clk ),
							 .iRST_N     ( DLY_RST_2 ),
							 .H_Cont     ( VGA_H_CNT ),						
						    .V_Cont     ( VGA_V_CNT )								
						);	
						
	 
//------AOTO FOCUS ENABLE  --
AUTO_FOCUS_ON  vd( 
                      .CLK_50      ( CLOCK2_50 ), 
                      .I2C_RELEASE ( I2C_RELEASE ), 
                      .AUTO_FOC    ( AUTO_FOC )
                ) ;
					
						

//------AOTO FOCUS ADJ  --
FOCUS_ADJ adl(
                      .CLK_50        ( CLOCK2_50 ) , 
                      .RESET_N       ( I2C_RELEASE ), 
                      .RESET_SUB_N   ( I2C_RELEASE ), 
                      //.AUTO_FOC      ( KEY[3] & AUTO_FOC ), 
							 .AUTO_FOC      ( !area_focus_run & AUTO_FOC ), 
							 
                      .SW_Y          ( 0 ),
                      .SW_H_FREQ     ( 0 ),   
							 
                      //.SW_FUC_LINE   ( SW[3] ),   
							 .SW_FUC_LINE   (area_focus_en ),
							 
                      .SW_FUC_ALL_CEN( 0 ),
                      .VIDEO_HS      ( lcd_hs ),
                      .VIDEO_VS      ( lcd_vs ),
							 .VIDEO_DE      ( LCD_DE  ), 
							 
                      .VIDEO_CLK     ( lcd_clk ),
                      .iR            ( R_AUTO ), 
                      .iG            ( G_AUTO ), 
                      .iB            ( B_AUTO ), 
                      .oR            ( lcd_r ) , 
                      .oG            ( lcd_g ) , 
                      .oB            ( lcd_b ) , 
                      
                      .READY         ( READY ),
                      .SCL           ( CAMERA_I2C_SCL_AF ), 
                      .SDA           ( CAMERA_I2C_SDA )
);

//------VS FREQUENCY TEST = 60HZ --
							
FpsMonitor uFps( 
	/*input					  */     .clk50    ( CLOCK2_50 ),
	/*input     			  */     .vs       ( MIPI_PIXEL_VS_ ),
	
	/*output reg [7:0]		*/    .fps      ( ),
	/*output reg [6:0]		*/    .hex_fps_h( HEX1 ),
	/*output reg [6:0]		*/    .hex_fps_l( HEX0 )
);
//------HEX OFF --
assign HEX2           = 7'h7F;
assign HEX3           = 7'h7F;
assign HEX4           = 7'h7F;
assign HEX5           = 7'h7F;
assign HEX6           = 7'h7F;
assign HEX7           = 7'h7F;


//--LED DISPLAY--
CLOCKMEM  ck1 ( .CLK(LCD_DCLK )   ,     .CLK_FREQ  (33333333) , . CK_1HZ (D8M_CK_HZ   )  ) ; //33.333MHZ
CLOCKMEM  ck2 ( .CLK(MIPI_REFCLK   )   ,.CLK_FREQ  (20000000) , . CK_1HZ (D8M_CK_HZ2  )  ) ; //20MHZ
CLOCKMEM  ck3 ( .CLK(MIPI_PIXEL_CLK)   ,.CLK_FREQ  (50000000) , . CK_1HZ (D8M_CK_HZ3  )  ) ; //50MHZ


assign LEDR = { D8M_CK_HZ ,D8M_CK_HZ2,D8M_CK_HZ3 ,5'h0,CAMERA_MIPI_RELAESE ,MIPI_BRIDGE_RELEASE  } ; 


//////////////////////////////////////

wire oREADY;
wire [7:0] gesture;
wire [3:0] touch_cnt;
wire touch_ready;

assign LEDG[0] = area_focus_en;


i2c_touch_config i2c_touch_config(
               //Host Side
               .iCLK(CLOCK2_50),
               .iRSTN( KEY[0]),
               .oREADY(touch_ready),
               .INT_n(TOUCH_INT_n),
               .oREG_GESTURE(gesture),
               .oREG_TOUCH_COUNT(touch_cnt),
               //I2C Side
               .I2C_SDAT(TOUCH_I2C_SDA),
               .I2C_SCLK(TOUCH_I2C_SCL)

 ); 

 wire area_focus_run;
 wire area_focus_en;
 
auto_focus_touch_ctrl auto_focus_touch_ctrl(
.iCLK(CLOCK2_50),
.iRST_n(KEY[0]),

.touch_int(TOUCH_INT_n),
.gesture(gesture),
.touch_cnt(touch_cnt),
.touch_ready(touch_ready),

.area_focus_en(area_focus_en),
.area_focus_run(area_focus_run)

);



endmodule
