`define ZOOM_IN 8'h48
`define ZOOM_OUT 8'h49

module auto_focus_touch_ctrl (
input iCLK,
input iRST_n,

input touch_int,
input [7:0] gesture,
input [3:0] touch_cnt,
input 		touch_ready,

output reg area_focus_en,
output reg area_focus_run



);



reg  state;

parameter state_idle = 1'b0;
parameter state_af_en = 1'b1;




always @(posedge iCLK or negedge iRST_n)
	begin
		if (~iRST_n)
			begin
                state  <=  3'b0;
					 area_focus_en <= 1'b0;
					 area_focus_run <= 1'b0;

         end
     else 
         begin
           case (state) //
			  
			  state_idle :  
					begin 
						if (touch_ready && (gesture == `ZOOM_IN))
							begin
								state <= state_af_en;
							   area_focus_en <= 1'b1;
							end
						else 
							begin
								area_focus_en <= 1'b0;							
								if (touch_ready && (touch_cnt == 4'h1))
									begin
										area_focus_run <= 1'b1;
									end 	
								else
									begin
										area_focus_run <= 1'b0;
									end	
							end	
					end 
			  state_af_en :
					begin 
						if (touch_ready && (gesture == `ZOOM_OUT))
							begin
								state <= state_idle;
								area_focus_en <= 1'b0;
							end
						else 
							begin
								if (touch_ready && (touch_cnt == 4'h1) )
									begin
										area_focus_run <= 1'b1;
									end	
								else 
									begin
										area_focus_run <= 1'b0;
									end
								
							end	
					end 			  
			  
			endcase  
		end	
 end


 
 endmodule 
