	component DE2_115_SOPC is
		port (
			ir_to_the_Irda                           : in    std_logic                     := 'X';             -- export
			pll_c0_out                               : out   std_logic;                                        -- clk
			pll_c2_out                               : out   std_logic;                                        -- clk
			pll_c3_out                               : out   std_logic;                                        -- clk
			pll_c4_out                               : out   std_logic;                                        -- clk
			clk_33                                   : in    std_logic                     := 'X';             -- clk
			clk_50                                   : in    std_logic                     := 'X';             -- clk
			dclk_from_the_epcs_flash_controller      : out   std_logic;                                        -- dclk
			sce_from_the_epcs_flash_controller       : out   std_logic;                                        -- sce
			sdo_from_the_epcs_flash_controller       : out   std_logic;                                        -- sdo
			data0_to_the_epcs_flash_controller       : in    std_logic                     := 'X';             -- data0
			LCD_RS_from_the_lcd                      : out   std_logic;                                        -- RS
			LCD_RW_from_the_lcd                      : out   std_logic;                                        -- RW
			LCD_data_to_and_from_the_lcd             : inout std_logic_vector(7 downto 0)  := (others => 'X'); -- data
			LCD_E_from_the_lcd                       : out   std_logic;                                        -- E
			reset_n                                  : in    std_logic                     := 'X';             -- reset_n
			in_port_to_the_pio_keys                  : in    std_logic_vector(3 downto 0)  := (others => 'X'); -- export
			areset_to_the_pll                        : in    std_logic                     := 'X';             -- export
			pll_c1_out                               : out   std_logic;                                        -- clk
			locked_from_the_pll                      : out   std_logic;                                        -- export
			phasedone_from_the_pll                   : out   std_logic;                                        -- export
			spi_data_out_from_the_sd_card_controller : out   std_logic;                                        -- data_out
			spi_data_in_to_the_sd_card_controller    : in    std_logic                     := 'X';             -- data_in
			spi_cs_n_from_the_sd_card_controller     : out   std_logic;                                        -- cs_n
			spi_clk_from_the_sd_card_controller      : out   std_logic;                                        -- clk
			zs_addr_from_the_sdram                   : out   std_logic_vector(12 downto 0);                    -- addr
			zs_ba_from_the_sdram                     : out   std_logic_vector(1 downto 0);                     -- ba
			zs_cas_n_from_the_sdram                  : out   std_logic;                                        -- cas_n
			zs_cke_from_the_sdram                    : out   std_logic;                                        -- cke
			zs_cs_n_from_the_sdram                   : out   std_logic;                                        -- cs_n
			zs_dq_to_and_from_the_sdram              : inout std_logic_vector(31 downto 0) := (others => 'X'); -- dq
			zs_dqm_from_the_sdram                    : out   std_logic_vector(3 downto 0);                     -- dqm
			zs_ras_n_from_the_sdram                  : out   std_logic;                                        -- ras_n
			zs_we_n_from_the_sdram                   : out   std_logic;                                        -- we_n
			SRAM_DQ_to_and_from_the_sram             : inout std_logic_vector(15 downto 0) := (others => 'X'); -- DQ
			SRAM_ADDR_from_the_sram                  : out   std_logic_vector(19 downto 0);                    -- ADDR
			SRAM_UB_n_from_the_sram                  : out   std_logic;                                        -- UB_n
			SRAM_LB_n_from_the_sram                  : out   std_logic;                                        -- LB_n
			SRAM_WE_n_from_the_sram                  : out   std_logic;                                        -- WE_n
			SRAM_CE_n_from_the_sram                  : out   std_logic;                                        -- CE_n
			SRAM_OE_n_from_the_sram                  : out   std_logic;                                        -- OE_n
			address_to_the_cfi_flash                 : out   std_logic_vector(22 downto 0);                    -- address_to_the_cfi_flash
			tri_state_bridge_flash_data              : inout std_logic_vector(7 downto 0)  := (others => 'X'); -- tri_state_bridge_flash_data
			write_n_to_the_cfi_flash                 : out   std_logic_vector(0 downto 0);                     -- write_n_to_the_cfi_flash
			select_n_to_the_cfi_flash                : out   std_logic_vector(0 downto 0);                     -- select_n_to_the_cfi_flash
			read_n_to_the_cfi_flash                  : out   std_logic_vector(0 downto 0);                     -- read_n_to_the_cfi_flash
			vga_clk_from_the_vga                     : out   std_logic;                                        -- clk
			vga_de_from_the_vga                      : out   std_logic;                                        -- de
			vga_r_from_the_vga                       : out   std_logic_vector(7 downto 0);                     -- r
			vga_g_from_the_vga                       : out   std_logic_vector(7 downto 0);                     -- g
			vga_b_from_the_vga                       : out   std_logic_vector(7 downto 0);                     -- b
			vga_hs_from_the_vga                      : out   std_logic;                                        -- hs
			vga_vs_from_the_vga                      : out   std_logic;                                        -- vs
			i2c_opencores_0_export_scl_pad_io        : inout std_logic                     := 'X';             -- scl_pad_io
			i2c_opencores_0_export_sda_pad_io        : inout std_logic                     := 'X';             -- sda_pad_io
			lcd_touch_int_external_connection_export : in    std_logic                     := 'X'              -- export
		);
	end component DE2_115_SOPC;

	u0 : component DE2_115_SOPC
		port map (
			ir_to_the_Irda                           => CONNECTED_TO_ir_to_the_Irda,                           --                       Irda_conduit_end.export
			pll_c0_out                               => CONNECTED_TO_pll_c0_out,                               --                             c0_out_clk.clk
			pll_c2_out                               => CONNECTED_TO_pll_c2_out,                               --                             c2_out_clk.clk
			pll_c3_out                               => CONNECTED_TO_pll_c3_out,                               --                             c3_out_clk.clk
			pll_c4_out                               => CONNECTED_TO_pll_c4_out,                               --                             c4_out_clk.clk
			clk_33                                   => CONNECTED_TO_clk_33,                                   --                          clk_33_clk_in.clk
			clk_50                                   => CONNECTED_TO_clk_50,                                   --                          clk_50_clk_in.clk
			dclk_from_the_epcs_flash_controller      => CONNECTED_TO_dclk_from_the_epcs_flash_controller,      --         epcs_flash_controller_external.dclk
			sce_from_the_epcs_flash_controller       => CONNECTED_TO_sce_from_the_epcs_flash_controller,       --                                       .sce
			sdo_from_the_epcs_flash_controller       => CONNECTED_TO_sdo_from_the_epcs_flash_controller,       --                                       .sdo
			data0_to_the_epcs_flash_controller       => CONNECTED_TO_data0_to_the_epcs_flash_controller,       --                                       .data0
			LCD_RS_from_the_lcd                      => CONNECTED_TO_LCD_RS_from_the_lcd,                      --                           lcd_external.RS
			LCD_RW_from_the_lcd                      => CONNECTED_TO_LCD_RW_from_the_lcd,                      --                                       .RW
			LCD_data_to_and_from_the_lcd             => CONNECTED_TO_LCD_data_to_and_from_the_lcd,             --                                       .data
			LCD_E_from_the_lcd                       => CONNECTED_TO_LCD_E_from_the_lcd,                       --                                       .E
			reset_n                                  => CONNECTED_TO_reset_n,                                  --                 merged_resets_in_reset.reset_n
			in_port_to_the_pio_keys                  => CONNECTED_TO_in_port_to_the_pio_keys,                  --           pio_keys_external_connection.export
			areset_to_the_pll                        => CONNECTED_TO_areset_to_the_pll,                        --                     pll_areset_conduit.export
			pll_c1_out                               => CONNECTED_TO_pll_c1_out,                               --                                 pll_c1.clk
			locked_from_the_pll                      => CONNECTED_TO_locked_from_the_pll,                      --                     pll_locked_conduit.export
			phasedone_from_the_pll                   => CONNECTED_TO_phasedone_from_the_pll,                   --                  pll_phasedone_conduit.export
			spi_data_out_from_the_sd_card_controller => CONNECTED_TO_spi_data_out_from_the_sd_card_controller, -- sd_card_controller_avalon_slave_export.data_out
			spi_data_in_to_the_sd_card_controller    => CONNECTED_TO_spi_data_in_to_the_sd_card_controller,    --                                       .data_in
			spi_cs_n_from_the_sd_card_controller     => CONNECTED_TO_spi_cs_n_from_the_sd_card_controller,     --                                       .cs_n
			spi_clk_from_the_sd_card_controller      => CONNECTED_TO_spi_clk_from_the_sd_card_controller,      --                                       .clk
			zs_addr_from_the_sdram                   => CONNECTED_TO_zs_addr_from_the_sdram,                   --                             sdram_wire.addr
			zs_ba_from_the_sdram                     => CONNECTED_TO_zs_ba_from_the_sdram,                     --                                       .ba
			zs_cas_n_from_the_sdram                  => CONNECTED_TO_zs_cas_n_from_the_sdram,                  --                                       .cas_n
			zs_cke_from_the_sdram                    => CONNECTED_TO_zs_cke_from_the_sdram,                    --                                       .cke
			zs_cs_n_from_the_sdram                   => CONNECTED_TO_zs_cs_n_from_the_sdram,                   --                                       .cs_n
			zs_dq_to_and_from_the_sdram              => CONNECTED_TO_zs_dq_to_and_from_the_sdram,              --                                       .dq
			zs_dqm_from_the_sdram                    => CONNECTED_TO_zs_dqm_from_the_sdram,                    --                                       .dqm
			zs_ras_n_from_the_sdram                  => CONNECTED_TO_zs_ras_n_from_the_sdram,                  --                                       .ras_n
			zs_we_n_from_the_sdram                   => CONNECTED_TO_zs_we_n_from_the_sdram,                   --                                       .we_n
			SRAM_DQ_to_and_from_the_sram             => CONNECTED_TO_SRAM_DQ_to_and_from_the_sram,             --                       sram_conduit_end.DQ
			SRAM_ADDR_from_the_sram                  => CONNECTED_TO_SRAM_ADDR_from_the_sram,                  --                                       .ADDR
			SRAM_UB_n_from_the_sram                  => CONNECTED_TO_SRAM_UB_n_from_the_sram,                  --                                       .UB_n
			SRAM_LB_n_from_the_sram                  => CONNECTED_TO_SRAM_LB_n_from_the_sram,                  --                                       .LB_n
			SRAM_WE_n_from_the_sram                  => CONNECTED_TO_SRAM_WE_n_from_the_sram,                  --                                       .WE_n
			SRAM_CE_n_from_the_sram                  => CONNECTED_TO_SRAM_CE_n_from_the_sram,                  --                                       .CE_n
			SRAM_OE_n_from_the_sram                  => CONNECTED_TO_SRAM_OE_n_from_the_sram,                  --                                       .OE_n
			address_to_the_cfi_flash                 => CONNECTED_TO_address_to_the_cfi_flash,                 --    tri_state_bridge_flash_bridge_0_out.address_to_the_cfi_flash
			tri_state_bridge_flash_data              => CONNECTED_TO_tri_state_bridge_flash_data,              --                                       .tri_state_bridge_flash_data
			write_n_to_the_cfi_flash                 => CONNECTED_TO_write_n_to_the_cfi_flash,                 --                                       .write_n_to_the_cfi_flash
			select_n_to_the_cfi_flash                => CONNECTED_TO_select_n_to_the_cfi_flash,                --                                       .select_n_to_the_cfi_flash
			read_n_to_the_cfi_flash                  => CONNECTED_TO_read_n_to_the_cfi_flash,                  --                                       .read_n_to_the_cfi_flash
			vga_clk_from_the_vga                     => CONNECTED_TO_vga_clk_from_the_vga,                     --                        vga_conduit_end.clk
			vga_de_from_the_vga                      => CONNECTED_TO_vga_de_from_the_vga,                      --                                       .de
			vga_r_from_the_vga                       => CONNECTED_TO_vga_r_from_the_vga,                       --                                       .r
			vga_g_from_the_vga                       => CONNECTED_TO_vga_g_from_the_vga,                       --                                       .g
			vga_b_from_the_vga                       => CONNECTED_TO_vga_b_from_the_vga,                       --                                       .b
			vga_hs_from_the_vga                      => CONNECTED_TO_vga_hs_from_the_vga,                      --                                       .hs
			vga_vs_from_the_vga                      => CONNECTED_TO_vga_vs_from_the_vga,                      --                                       .vs
			i2c_opencores_0_export_scl_pad_io        => CONNECTED_TO_i2c_opencores_0_export_scl_pad_io,        --                 i2c_opencores_0_export.scl_pad_io
			i2c_opencores_0_export_sda_pad_io        => CONNECTED_TO_i2c_opencores_0_export_sda_pad_io,        --                                       .sda_pad_io
			lcd_touch_int_external_connection_export => CONNECTED_TO_lcd_touch_int_external_connection_export  --      lcd_touch_int_external_connection.export
		);

