// ============================================================================
// Copyright (c) 2014 by Terasic Technologies Inc.
// ============================================================================
//
// Permission:
//
//   Terasic grants permission to use and modify this code for use
//   in synthesis for all Terasic Development Boards and Altera Development 
//   Kits made by Terasic.  Other use of this code, including the selling 
//   ,duplication, or modification of any portion is strictly prohibited.
//
// Disclaimer:
//
//   This VHDL/Verilog or C/C++ source code is intended as a design reference
//   which illustrates how these types of functions can be implemented.
//   It is the user's responsibility to verify their design for
//   consistency and functionality through the use of formal
//   verification methods.  Terasic provides no warranty regarding the use 
//   or functionality of this code.
//
// ============================================================================
//           
//  Terasic Technologies Inc
//  9F., No.176, Sec.2, Gongdao 5th Rd, East Dist, Hsinchu City, 30070. Taiwan
//
//
//
//                     web: http://www.terasic.com/
//                     email: support@terasic.com
//

// --------------------------------------------------------------------
//
// Major Functions:	VIP demonstration
//
// --------------------------------------------------------------------
// Revision History :
// --------------------------------------------------------------------
//   Ver  :| Author            :| Mod. Date :| Changes Made:
//   V1.0 :| Peli Li           :| 08/25/2011:| initial version for VEEK-MT
//   V1.0 :| Richard           :| 04/29/2016:| porting to VEEK-MT2
// --------------------------------------------------------------------

module VIP
(
	//////////// CLOCK //////////
	input 		          		CLOCK2_50,
	input 		          		CLOCK3_50,
	input 		          		CLOCK_50,

	//////////// Sma //////////
	input 		          		SMA_CLKIN,
	output		          		SMA_CLKOUT,

	//////////// LED //////////
	output		     [8:0]		LEDG,
	output		    [17:0]		LEDR,

	//////////// KEY //////////
	input 		     [3:0]		KEY,

	//////////// EX_IO //////////
	inout 		     [6:0]		EX_IO,

	//////////// SW //////////
	input 		    [17:0]		SW,

	//////////// SEG7 //////////
	output		     [6:0]		HEX0,
	output		     [6:0]		HEX1,
	output		     [6:0]		HEX2,
	output		     [6:0]		HEX3,
	output		     [6:0]		HEX4,
	output		     [6:0]		HEX5,
	output		     [6:0]		HEX6,
	output		     [6:0]		HEX7,

	//////////// LCD //////////
	output		          		LCD_BLON,
	inout 		     [7:0]		LCD_DATA,
	output		          		LCD_EN,
	output		          		LCD_ON,
	output		          		LCD_RS,
	output		          		LCD_RW,

	//////////// RS232 //////////
	input 		          		UART_CTS,
	output		          		UART_RTS,
	input 		          		UART_RXD,
	output		          		UART_TXD,

	//////////// PS2 for Keyboard and Mouse //////////
	inout 		          		PS2_CLK,
	inout 		          		PS2_CLK2,
	inout 		          		PS2_DAT,
	inout 		          		PS2_DAT2,

	//////////// SDCARD //////////
	output		          		SD_CLK,
	inout 		          		SD_CMD,
	inout 		     [3:0]		SD_DAT,
	input 		          		SD_WP_N,

	//////////// VGA //////////
	output		          		VGA_BLANK_N,
	output		     [7:0]		VGA_B,
	output		          		VGA_CLK,
	output		     [7:0]		VGA_G,
	output		          		VGA_HS,
	output		     [7:0]		VGA_R,
	output		          		VGA_SYNC_N,
	output		          		VGA_VS,

	//////////// Audio //////////
	input 		          		AUD_ADCDAT,
	inout 		          		AUD_ADCLRCK,
	inout 		          		AUD_BCLK,
	output		          		AUD_DACDAT,
	inout 		          		AUD_DACLRCK,
	output		          		AUD_XCK,

	//////////// I2C for EEPROM //////////
	output		          		EEP_I2C_SCLK,
	inout 		          		EEP_I2C_SDAT,

	//////////// I2C for Audio Tv-Decoder HSMC  //////////
	output		          		I2C_SCLK,
	inout 		          		I2C_SDAT,

	//////////// Ethernet 0 //////////
	output		          		ENET0_GTX_CLK,
	input 		          		ENET0_INT_N,
	input 		          		ENET0_LINK100,
	output		          		ENET0_MDC,
	inout 		          		ENET0_MDIO,
	output		          		ENET0_RST_N,
	input 		          		ENET0_RX_CLK,
	input 		          		ENET0_RX_COL,
	input 		          		ENET0_RX_CRS,
	input 		     [3:0]		ENET0_RX_DATA,
	input 		          		ENET0_RX_DV,
	input 		          		ENET0_RX_ER,
	input 		          		ENET0_TX_CLK,
	output		     [3:0]		ENET0_TX_DATA,
	output		          		ENET0_TX_EN,
	output		          		ENET0_TX_ER,
	input 		          		ENETCLK_25,

	//////////// Ethernet 1 //////////
	output		          		ENET1_GTX_CLK,
	input 		          		ENET1_INT_N,
	input 		          		ENET1_LINK100,
	output		          		ENET1_MDC,
	inout 		          		ENET1_MDIO,
	output		          		ENET1_RST_N,
	input 		          		ENET1_RX_CLK,
	input 		          		ENET1_RX_COL,
	input 		          		ENET1_RX_CRS,
	input 		     [3:0]		ENET1_RX_DATA,
	input 		          		ENET1_RX_DV,
	input 		          		ENET1_RX_ER,
	input 		          		ENET1_TX_CLK,
	output		     [3:0]		ENET1_TX_DATA,
	output		          		ENET1_TX_EN,
	output		          		ENET1_TX_ER,

	//////////// TV Decoder //////////
	input 		          		TD_CLK27,
	input 		     [7:0]		TD_DATA,
	input 		          		TD_HS,
	output		          		TD_RESET_N,
	input 		          		TD_VS,

	//////////// USB 2.0 OTG (Cypress CY7C67200) //////////
	output		     [1:0]		OTG_ADDR,
	output		          		OTG_CS_N,
	inout 		    [15:0]		OTG_DATA,
	input 		          		OTG_INT,
	output		          		OTG_RD_N,
	output		          		OTG_RST_N,
	output		          		OTG_WE_N,

	//////////// IR Receiver //////////
	input 		          		IRDA_RXD,

	//////////// SDRAM //////////
	output		    [12:0]		DRAM_ADDR,
	output		     [1:0]		DRAM_BA,
	output		          		DRAM_CAS_N,
	output		          		DRAM_CKE,
	output		          		DRAM_CLK,
	output		          		DRAM_CS_N,
	inout 		    [31:0]		DRAM_DQ,
	output		     [3:0]		DRAM_DQM,
	output		          		DRAM_RAS_N,
	output		          		DRAM_WE_N,

	//////////// SRAM //////////
	output		    [19:0]		SRAM_ADDR,
	output		          		SRAM_CE_N,
	inout 		    [15:0]		SRAM_DQ,
	output		          		SRAM_LB_N,
	output		          		SRAM_OE_N,
	output		          		SRAM_UB_N,
	output		          		SRAM_WE_N,

	//////////// Flash //////////
	output		    [22:0]		FL_ADDR,
	output		          		FL_CE_N,
	inout 		     [7:0]		FL_DQ,
	output		          		FL_OE_N,
	output		          		FL_RST_N,
	input 		          		FL_RY,
	output		          		FL_WE_N,
	output		          		FL_WP_N,

	//////////// GPIO, GPIO connect to GPIO Default //////////
	inout 		    [35:0]		GPIO,

	//////////// HSMC, HSMC connect to MTLC2 -Multi-Touch/LCD/Camera //////////
	inout 		          		CAMERA_I2C_SCL,
	inout 		          		CAMERA_I2C_SDA,
	output		          		CAMERA_PWDN_n,
	output		     [7:0]		LCD_B,
	output		          		LCD_DCLK,
	output		          		LCD_DE,
	output		          		LCD_DIM,
	output		          		LCD_DITH,
	output		     [7:0]		LCD_G,
	output		          		LCD_HSD,
	output		          		LCD_MODE,
	output		          		LCD_POWER_CTL,
	output		          		LCD_RSTB,
	output		     [7:0]		LCD_R,
	output		          		LCD_SHLR,
	output		          		LCD_UPDN,
	output		          		LCD_VSD,
	output		          		LSENSOR_ADDR_SEL,
	input 		          		LSENSOR_INT,
	inout 		          		LSENSOR_SCL,
	inout 		          		LSENSOR_SDA,
	output		          		MIPI_CS_n,
	inout 		          		MIPI_I2C_SCL,
	inout 		          		MIPI_I2C_SDA,
	output		          		MIPI_MCLK,
	input 		          		MIPI_PIXEL_CLK,
	input 		    [13:0]		MIPI_PIXEL_D,
	input 		          		MIPI_PIXEL_HS,
	input 		          		MIPI_PIXEL_VS,
	output		          		MIPI_REFCLK,
	output		          		MIPI_RESET_n,
	output		          		MPU_AD0_SDO,
	output		          		MPU_CS_n,
	output		          		MPU_FSYNC,
	input 		          		MPU_INT,
	inout 		          		MPU_SCL_SCLK,
	inout 		          		MPU_SDA_SDI,
	inout 		          		TOUCH_I2C_SCL,
	inout 		          		TOUCH_I2C_SDA,
	input 		          		TOUCH_INT_n
);


//=======================================================
//  Structural coding
//=======================================================
//define wire
  wire h_sync;
  wire v_sync;

  wire vga_base_clock;
  wire vga_clock; // *3 of the base clock
  wire [23:0] wire_VGA_DATA;
  wire wire_VGA_BLANK;
  wire wire_VGA_HS;
  wire wire_VGA_VS;

  wire lcd_base_clock;
  wire lcd_clock; // *3 of the base clock
  wire [23:0] LCD_RGB;
  wire LCD_BLANK;
  wire LCD_HS;
  wire LCD_VS;
  wire clk_100;
  wire clk_40;
  wire clk_mtlc;
  wire video_hs;
  wire video_vs;
  wire locked;
  
  //wire clk_touch;
assign LCD_MODE = 1'b1;  //DE mode
assign LCD_RSTB = locked &KEY[3]; //NO RESET
assign LCD_DIM  = 1'b1;
assign LCD_POWER_CTL = 1'b1;
assign LCD_SHLR  	= 1'b1;
assign LCD_UPDN 	= 1'b0;
assign LCD_DITH 	= 1'b0;

//audio
assign	AUD_ADCLRCK	=	AUD_DACLRCK;
  
DE2_115_QSYS DE2_115_QSYS_inst
    (
      //clock
      .clk_50                                        (CLOCK_50),
      .clk_sdram                                     (DRAM_CLK),
      .clk_sys                                       (clk_100),
		.clk_mtlc                                      (clk_mtlc),
      //reset
      .reset_n                                       (1'b1),
		.locked_from_the_altpll_0                      (locked),
      
      //button
      .in_port_to_the_button_pio                     (KEY),
      
      //LED
      .out_port_from_the_led_pio                     (LEDG),
      
      //sram
      .SRAM_ADDR_from_the_sram                       (SRAM_ADDR),
      .SRAM_CE_n_from_the_sram                       (SRAM_CE_N),
      .SRAM_DQ_to_and_from_the_sram                  (SRAM_DQ),
      .SRAM_LB_n_from_the_sram                       (SRAM_LB_N),
      .SRAM_OE_n_from_the_sram                       (SRAM_OE_N),
      .SRAM_UB_n_from_the_sram                       (SRAM_UB_N),
      .SRAM_WE_n_from_the_sram                       (SRAM_WE_N),
      
      //audio
      .audio_BCLK_from_the_audio_avalon_controller   (AUD_BCLK),
      .audio_CLK_from_the_audio_avalon_controller    (AUD_XCK),
      .audio_DIN_from_the_audio_avalon_controller    (AUD_DACDAT),
      .audio_DOUT_to_the_audio_avalon_controller     (AUD_ADCDAT),
      .audio_LRCIN_from_the_audio_avalon_controller  (),
      .audio_LRCOUT_from_the_audio_avalon_controller (audio_LRCOUT_from_the_audio_avalon_controller),
      
      //TV and audio i2c
      .bidir_port_to_and_from_the_av_i2c_data_pio    (I2C_SDAT),
      .out_port_from_the_av_i2c_clk_pio              (I2C_SCLK),
      
      //TV
      .out_port_from_the_td_reset_pio                (TD_RESET_N),
		.alt_vip_cti_0_clocked_video_vid_clk           (TD_CLK27),
      .alt_vip_cti_0_clocked_video_vid_data          (TD_DATA),
      .alt_vip_cti_0_clocked_video_vid_datavalid     (locked),
      .alt_vip_cti_0_clocked_video_vid_locked        (locked),
      
      //vga
      .vid_clk_to_the_alt_vip_itc_0                  (clk_mtlc),
      .vid_data_from_the_alt_vip_itc_0               (wire_VGA_DATA),
      .vid_datavalid_from_the_alt_vip_itc_0          (),
      .vid_h_sync_from_the_alt_vip_itc_0             (wire_VGA_HS),
      .vid_v_sync_from_the_alt_vip_itc_0             (wire_VGA_VS),
      
		// the_multi_touch
      .touch_i2c_opencores_export_scl_pad_io         (TOUCH_I2C_SCL),
      .touch_i2c_opencores_export_sda_pad_io         (TOUCH_I2C_SDA),
      .touch_int_n_external_connection_export        (TOUCH_INT_n),         //     touch_int_n_external_connection.export
		
		
      //mtlc2 
      .vid_clk_to_the_alt_vip_itc_1                  (clk_mtlc),
      .vid_data_from_the_alt_vip_itc_1               (LCD_RGB),
      .vid_datavalid_from_the_alt_vip_itc_1          (LCD_DE),    //add by peli 8-24
      .vid_h_sync_from_the_alt_vip_itc_1             (video_hs),
      .vid_v_sync_from_the_alt_vip_itc_1             (video_vs),    
      
      //sdram
      .zs_addr_from_the_sdram                        (DRAM_ADDR),
      .zs_ba_from_the_sdram                          (DRAM_BA),
      .zs_cas_n_from_the_sdram                       (DRAM_CAS_N),
      .zs_cke_from_the_sdram                         (DRAM_CKE),
      .zs_cs_n_from_the_sdram                        (DRAM_CS_N),
      .zs_dq_to_and_from_the_sdram                   (DRAM_DQ),
      .zs_dqm_from_the_sdram                         (DRAM_DQM),
      .zs_ras_n_from_the_sdram                       (DRAM_RAS_N),
      .zs_we_n_from_the_sdram                        (DRAM_WE_N),
		
		// the_tri_state_bridge_flash_avalon_slave
      .address_to_the_cfi_flash                      (FL_ADDR),
      .read_n_to_the_cfi_flash                       (FL_OE_N),
      .select_n_to_the_cfi_flash                     (FL_CE_N),
      .tri_state_bridge_flash_data                   (FL_DQ),
      .write_n_to_the_cfi_flash                      (FL_WE_N)
    );

	 // Flash Config
assign	FL_RST_N = 1'b1;
assign	FL_WP_N = 1'b1;
////vga signal assignments
assign   VGA_CLK = clk_mtlc;

assign VGA_SYNC_N = 1'b0;
assign VGA_BLANK_N = 1'b1;

assign   VGA_HS = ~video_hs;
assign   VGA_VS = ~video_vs;

assign   VGA_R = LCD_RGB[23:16];
assign   VGA_G = LCD_RGB[15:8];
assign   VGA_B = LCD_RGB[7:0];

////MTLC2 - display
assign  LCD_R = LCD_RGB[23:16];
assign  LCD_G = LCD_RGB[15:8];
assign  LCD_B = LCD_RGB[7:0];

assign  LCD_HSD = ~video_hs;
assign  LCD_VSD = ~video_vs;
assign  LCD_DCLK = clk_mtlc;

endmodule


